-- Class
Item = class("Item")

kItemEffect_Fast = 1
kItemEffect_Slow = 2
kItemEffect_Flip = 3

-- effectType : 1,2,3
function Item:initialize(x,y,r,effectType)
	super.initialize(self)

	self.x = x
	self.y = y
	self.radius = r
	self.effectType = effectType
end

function Item:draw()
	if self.effectType == kItemEffect_Flip then
		love.graphics.setColor( 0, 0, 255, 196 )
	elseif self.effectType == kItemEffect_Fast then
		love.graphics.setColor( 0, 255, 0, 196 )
	elseif self.effectType == kItemEffect_Slow then
		love.graphics.setColor( 255, 0, 0, 196 )
	end
	 
	local radius = 2 * self.radius
	love.graphics.setLineWidth(1./_globalScale_ * _screenWidth_/200)
	love.graphics.triangle("line", self.x - radius/2, self.y - radius/2,  
			self.x + radius/2, self.y - radius/2, 
			self.x, self.y + radius/2)
end

function Item:destroy()
	for k,item in pairs(gGame.level.items) do
		if item == self then
			gGame.level.items[k] = nil
		end
	end
end

function Item:update(dt)
	for k,player in pairs(gGame.players) do
		local d = dist2(player.x, player.y, self.x, self.y)
		if d <= self.radius * 2 then
		
			if self.effectType == kItemEffect_Flip then
				gGame:activateFlip()
				-- TODO:shake!!
			elseif self.effectType == kItemEffect_Fast then
				player:boost(true)
			elseif self.effectType == kItemEffect_Slow then
				player:boost(false)
			end
			
			self:destroy()
		end
	end
end
