-- Class
Level = class("Level")

function Level:initialize()
	super.initialize(self)
	self.parts = {}
	self.obstacles = {}
	self.items = {}
	self.LevelYBase = love.graphics.getHeight()
end

-- points : x0,y0, x1,y1, ...
function Level:addPart(points)
	table.insert(self.parts, points)
end

-- points : x0,y0, x1,y1, ...
function Level:addObstacle(points)
	table.insert(self.obstacles, points)
end

function Level:drawPart(mode, points)
	if points[3] > -_globalTranslateX_ and points[1] < (-_globalTranslateX_ + _screenWidth_)/_globalScale_ then
		love.graphics.quad(mode, unpack(points))
	end
end

function Level:addItem(item)
	table.insert(self.items, item)
end

function Level:update(dt)
	for k,item in pairs(self.items) do
		item:update(dt)
	end
end

function Level:draw()
	-- obstacles
	love.graphics.setLineWidth(1./_globalScale_ * _screenWidth_/200)
	local gray = 155
	local grayUpdate = 25
	for k,part in pairs(self.obstacles) do
		gray = gray + grayUpdate
		if gray > 220 then
			gray = 220
			grayUpdate = -25
		elseif gray < 100 then
			gray = 100
			grayUpdate = 25
		end
		love.graphics.setColor(gray, 0, 0, 255)
		self:drawPart("fill", part)
		love.graphics.setColor(255, 0, 0, 255)
		self:drawPart("line", part)
	end
	
	-- ground
	love.graphics.setLineWidth(1./_globalScale_ * _screenWidth_/200)
	local gray = 155
	local grayUpdate = 5
	for k,part in pairs(self.parts) do
		gray = gray + grayUpdate
		if gray > 255 then
			gray = 255
			grayUpdate = -5
		elseif gray < 100 then
			gray = 100
			grayUpdate = 5
		end
		love.graphics.setColor(gray, gray, gray, 255)
		self:drawPart("fill", part)
	end

	for k,item in pairs(self.items) do
		item:draw()
	end
	
	-- draw end line
	for i = 1,50 do
		love.graphics.setColor(0, 255, 0, 255/i)
		local x = gGame.levelEndX + (i-1) * 10
		love.graphics.line(x, 0, x, _screenHeight_)
	end
end
