-- Class
Music = class("Music")

function Music:initialize(filename, pitch)
	super.initialize(self)
	
	self.filename = filename
	self.source = love.audio.newSource(self.filename, "stream")
	self.source:setLooping(true)
	self.source:setPitch(pitch)
	
	love.audio.play( self.source )
end

function Music:setPitch(pitch)
	self.source:setPitch(pitch)
end

function Music:getPitch()
	return self.source:getPitch()
end

function Music:stop()
	return self.source:stop()
end

