
-- see http://www.mine-control.com/zack/timesync/timesync.html


local t = GetCurTime()
local dt = 0
local countSend = 0
local countReceived = 0

function NetTime_GetServerTime ()
	if IsServer() then
		return GetCurTime()
	else
		return t
	end
end

local timer = cTimer:new(1)

function NetTime_Draw ()
	love.graphics.setColor(255,255,255,255)
	love.graphics.print(
		"time: " .. (math.floor(t * 10) / 10) .. 
		" lastdt: " .. (math.floor(dt * 10) / 10) ..
		" count: " .. countSend .. "/" .. countReceived ..
		""
		, 2, _screenHeight_ - 40)
end

function NetTime_Step (dt)
	if IsServer() then
		t = GetCurTime()
	else
		t = t + dt
	end
	
	if not IsServer() and gHostID and timer:updateAndCheck(dt) then
		NetTime_SendRequest ()
	end
end

function NetTime_SendSetTime (clientId)
	--~ print("NetTime_SendSetTime", clientId)
	Network_SendReliableToClient(clientId, {kNetMsg_SetTime, NetTime_GetServerTime()})
end

function NetTime_SendRequest ()
	--~ print("NetTime_SendRequest", t)
	Network_SendToClient(gHostID, {kNetMsg_TimeRequest, Network_GetOwnID(), t})
	countSend = countSend + 1
end

function NetTime_ReceivedRequest (otherClientId, timestamp)
	--~ print("NetTime_ReceivedRequest",otherClientId, timestamp)
	Network_SendToClient(otherClientId, {kNetMsg_TimeResponse, Network_GetOwnID(), t, timestamp})
end

function NetTime_ReceivedResponse (otherClientId, timestampOther, timeMine)
	--~ print("NetTime_ReceivedResponse", otherClientId, timestampOther, timeMine)
	local latency = (t - timeMine) / 2
	local otherNow = (timestampOther + latency)
	dt = otherNow - t
	t = (t + otherNow)/2
	countReceived = countReceived + 1
end

function NetTime_ReceivedSetTime (timestamp)
	--~ print("NetTime_ReceivedSetTime", timestamp)
	if not IsServer() then t = timestamp end
end
