
local pingTimer = cTimer:new(1)

local lastPingTime = 0
local lastPingId = 0
local timeUntilRemovePlayer = 60*2

-- last roundtrip
local playerPingTimeMap = {}
-- last timestamp of pong message
local playerPongTimeMap = {}

function Ping_Draw ()
	if true then

		local x,y,dx,dy = 2,_screenHeight_-160, 0,15
		
		local t = GetCurTime()
		
		for id,ping in pairs(playerPingTimeMap) do
			local prefix = " "
			
			if id == gHostID then
				prefix = "*"
			elseif id == Network_GetOwnID() then
				prefix = "-"
			end
			
			local deltaT = t - playerPongTimeMap[id]
			
			if deltaT > timeUntilRemovePlayer then
				playerPingTimeMap[id] = nil
			else
				local a = 255 - math.floor(MapFromTo (deltaT, 0, 500, 0, 100))
				local r,g,b = Vector.lerp(0,255,0, 255,0,0, MapFromTo (ping, 0, 10, 0, 1))
				
				love.graphics.setColor(r,g,b,a)

				local name = gNickByHostId[id] or id

				love.graphics.print(prefix .. name .. " ... " .. 
					math.floor(ping * 100) .. "ms " .. 
					math.floor(deltaT) .. "s", x, y)
				x = x + dx
				y = y + dy
			end
		end
	
	end
end

function Ping_Pong (clientId, pingId)
	local t = GetCurTime()
	
	playerPongTimeMap[clientId] = t
	
	if pingId == lastPingId then
		playerPingTimeMap[clientId] = t - lastPingTime
	end
end 

function Ping_Step (dt)
	if pingTimer:updateAndCheck(dt) then
		lastPingTime = GetCurTime()
		lastPingId = math.random(1,10000)
		
		--~ print("SEND PING", Network_GetOwnID(), lastPingId)
		
		Network_Send({kNetMsg_Ping, Network_GetOwnID(), lastPingId})
	end
end
